#ifndef _SDG_EVENT_H_
#define _SDG_EVENT_H_

#include"sdg_head.h"
#include"sdg_x.h"

/*٥ѿ*/

/*٥ȥޥ*/
#define SDG_EXPOSE_MASK ExposureMask
#define SDG_BUTTON_PRESS_MASK ButtonPressMask
#define SDG_BUTTON_RELEASE_MASK ButtonReleaseMask
#define SDG_KEY_PRESS_MASK KeyPressMask
#define SDG_KEY_RELEASE_MASK KeyReleaseMask

/*٥Ȥμ*/
typedef enum{
	NO_EVENT = 0,
	EXPOSE,
	BUTTON_PRESS,
	BUTTON_RELEASE,
	KEY_PRESS,
	KEY_RELEASE,
}sdg_event_type_t;

/*٥ȤȤѿ*/

/*Ƥ˶̤ѿ*/
typedef struct{
	sdg_event_type_t type; /*٥ȤΥ*/
	sdg_widget_t *target; /*٥Ȥȯå*/
}sdg_event_any_t;

/*ܥ(ޥ)*/
typedef struct{
	sdg_event_type_t type;
	sdg_widget_t *target;
	sdg_u16 x,y;
	sdg_u8 button; /*줿ܥֹ(=1,=2,=3)*/
}sdg_event_button_t;

/*ܡ*/
typedef struct{
	sdg_event_type_t type;
	sdg_widget_t *target;
	sdg_u32 mask; /*CtrlʤɤƤ뤫*/
	sdg_u32 keycode; /**/
}sdg_event_key_t;

/*褬ɬפʤȤΥ٥*/
typedef struct{
	sdg_event_type_t type;
	sdg_widget_t *target;
	sdg_u16 x,y,width,height; /*ߤΥåȤΥ*/
}sdg_event_expose_t;

/*٥ȤΥ롼ѿ*/
typedef union{
	sdg_event_type_t type;
	sdg_event_any_t any;
	sdg_event_button_t button;
	sdg_event_key_t key;
	sdg_event_expose_t expose;
}sdg_event_t;

/*٥ȴؿ*/
void sdg_event_set(sdg_widget_t *widget,sdg_u32 mask);
void sdg_event_wait(sdg_event_t *event);
sdg_boolean_t sdg_event_get(sdg_widget_t *widget,sdg_event_t *event);

#endif